#ifndef DEV_H_
#define DEV_H_

#define MAX_IRQS  10          /* Do you know ANY isa device w/ 10 IRQs? */

typedef struct property {
 char *name;
 char *value;
 struct property *next;
}property;

typedef struct isadev {
 char *name;
 int iobase;
 int irqs[MAX_IRQS];
 int nirqs;
 property *properties;
 struct isadev *next;
}isadev;

#ifdef __cplusplus
extern "C" {
#endif

extern isadev *alloc_isadev (void);
extern void setisadevname(isadev *dev,char *name);
extern void init_dev();
extern void dump_devices();
extern void addisadev(isadev *dev);
extern void setisadevport(isadev *dev,int port);
extern void allocisadevirq(isadev *dev,int irq);
extern void add_isadevproperty(isadev *dev,char *name,char *value);
extern void add_isadevpropertyf(isadev *dev,char *name,char *fmt,...);

extern int ask_for_probe(char *name,int port);

#ifdef __cplusplus
 };
#endif

#endif
