#include <stdio.h>
#include <conio.h>
#include <dos.h>

#include "dev.h"
#include "hgc.h"
#include "misc.h"

int in_mda(unsigned char reg)
{
 int val;

 _disable();
 outp(0x3b4,reg);
 val = inp(0x3b5);
 _enable();
 return val;
}

void out_mda(unsigned char reg,int val)
{
 _disable();
 outp(0x3b4,reg);
 outp(0x3b5,val);
 _enable();
}


int 
hgc_probe (void)
{
  unsigned short far *mem = (unsigned short far *) MK_FP (0xb000, 0x0000);
  unsigned short save,save2;
  int oldtick;
  char *card_name;
  isadev *dev;

  if (!ask_for_probe("Hercules Graphics Card",0x3b0))
    return 0;

  save = mem[0];
  mem[0] = 0xAA55;
  if (mem[0] != 0xAA55)
    {
      mem[0] = save;
      return 0;
    }
  mem[0] = 0x55AA;
  if (mem[0] != 0x55AA)
    {
      mem[0] = save;
      return 0;
    }
  mem[0] = save;

  save = in_mda(0xf);
  out_mda(0xf,0x66);
  if (in_mda(0xf)!=0x66)
    return 0;
  out_mda(0xf,0x99);
  if (in_mda(0xf)!=0x99)
    return 0;
  out_mda(0xf,save);

  oldtick = gettick();
  save = inp(0x3ba) & 0x80;        /* VSYNC_STATUS */

  while (gettick()<oldtick+3)
  {
   save2 = inp(0x3ba) & 0x80;
   if (save!=save2)
    break;
  }

  if (save==save2)
    return 0;

  /* This is black magic... */
  switch (inp(0x3ba) & 0x70) {
    case 0x10:card_name = "Hercules Plus Graphics Card";break;
    case 0x50:card_name = "Hercules Color Graphics Card";break;
    default:  card_name = "Hercules Graphics Card";break;
  }

  printf ("hgc_probe: HGC found, type %s\n",card_name);
  printf ("hgc_probe: mem=0xb000, io=0x3b0-0x3bf\n");
  return 1;
}
