#include <dos.h>
#include "irqprobe.h"

typedef void interrupt (*irqprobe_oldhandler) (void);
irqprobe_oldhandler irqprobe_old[16];
int irqprobe_imask0, irqprobe_imask1;
void far (*irqprobe_func) (int irqnum);

#define MAKE_IRQ_HANDLER(n) \
	void interrupt irq##n##_handler(void) \
	{ \
	 _disable(); \
	 outp(n>=8?0xA0:0x20,0x20); \
	 irqprobe_func(n); \
	 _enable(); \
	 irqprobe_old[n](); \
        } \

MAKE_IRQ_HANDLER (0)
MAKE_IRQ_HANDLER (1)
MAKE_IRQ_HANDLER (2)
MAKE_IRQ_HANDLER (3)
MAKE_IRQ_HANDLER (4)
MAKE_IRQ_HANDLER (5)
MAKE_IRQ_HANDLER (6)
MAKE_IRQ_HANDLER (7)
MAKE_IRQ_HANDLER (8)
MAKE_IRQ_HANDLER (9)
MAKE_IRQ_HANDLER (10)
MAKE_IRQ_HANDLER (11)
MAKE_IRQ_HANDLER (12)
MAKE_IRQ_HANDLER (13)
MAKE_IRQ_HANDLER (14)
MAKE_IRQ_HANDLER (15)

void
init_irqprobe (void far (*callback) (int irqnum))
{
  int i;

  irqprobe_func = callback;

  irqprobe_imask0 = inp (0x21);
  irqprobe_imask1 = inp (0xA1);
  for (i = 0; i < 8; i++)
    irqprobe_old[i] = getvect (0x08 + i);
  for (i = 0; i < 8; i++)
    irqprobe_old[i + 8] = getvect (0x70 + i);
  /*
  for (i=0;i<=15;i++)
    printf("irq%u=%Fp%c",i,irqprobe_old[i],i==15?'\n':',');
  */
  setvect (0x08, irq0_handler);
  setvect (0x09, irq1_handler);
  setvect (0x0a, irq2_handler);
  setvect (0x0b, irq3_handler);
  setvect (0x0c, irq4_handler);
  setvect (0x0d, irq5_handler);
  setvect (0x0e, irq6_handler);
  setvect (0x0f, irq7_handler);
  setvect (0x70, irq8_handler);
  setvect (0x71, irq9_handler);
  setvect (0x72, irq10_handler);
  setvect (0x73, irq11_handler);
  setvect (0x74, irq12_handler);
  setvect (0x75, irq13_handler);
  setvect (0x76, irq14_handler);
  setvect (0x75, irq15_handler);
  outp (0x21, 0);
  outp (0xA1, 0);
}

void
done_irqprobe (void)
{
  int i;

  outp (0x21, irqprobe_imask0);
  outp (0xA1, irqprobe_imask1);
  for (i = 0; i < 8; i++)
    setvect (0x08 + i, irqprobe_old[i]);
  for (i = 0; i < 8; i++)
    setvect (0x70 + i, irqprobe_old[i + 8]);
}
