#ifndef __ICL16_H
#define __ICL16_H


/* Jumperless Configuration Register (BMPR19) */
#define JUMPERLESS_CONFIG      19

/* NMC93CSx6 EEPROM Control Bits */
#define CS_0                   0x00
#define CS_1                   0x20
#define SK_0                   0x00
#define SK_1                   0x40
#define DI_0                   0x00
#define DI_1                   0x80

/* NMC93CSx6 EEPROM Instructions */
#define EEPROM_READ            0x80

/* NMC93CSx6 EEPROM Addresses */
#define E_NODEID_0             0x02
#define E_NODEID_1             0x03
#define E_NODEID_2             0x04
#define E_PORT_SELECT          0x14
  #define E_PORT_BNC           0x00
  #define E_PORT_DIX           0x01
  #define E_PORT_TP            0x02
  #define E_PORT_AUTO          0x03
  #define E_PORT_FROM_EPROM    0x04
#define E_PRODUCT_CFG          0x30


/* EEPROM Control Register (BMPR 16) */
#define EEPROM_CTRL_REG        16

/* EEPROM Data Register (BMPR 17) */
#define EEPROM_DATA_REG        17

/* Transmit Mode Register (DLCR4) */
#define TRANSMIT_MODE_REG      4

#define EISA_IRQ_REG	0xc89

#ifdef __cplusplus
extern "C" {
#endif

extern int icl16_probe (int ioaddr);

#ifdef __cplusplus
 };
#endif


#endif